//
//  AppDelegate.m
//  QCloudSDKDemo
//
//  Created by Sword on 2019/2/26.
//  Copyright © 2019 Tencent. All rights reserved.
//

#import "QDAppDelegate.h"
#import "QDDefine.h"
#import "Reachability.h"
#import <CoreTelephony/CTTelephonyNetworkInfo.h>

@interface QDAppDelegate ()

@property (nonatomic) Reachability *internetReachability;

@end

@implementation QDAppDelegate

- (void)checkQCloudAppInfo
{
//    NSAssert([kQDAppId length] > 0, @"appid is not set");
//    NSAssert([kQDSecretId length] > 0, @"secretId is not set");
//    NSAssert([kQDSecretKey length] > 0, @"secretKey is not set");
}

/*!
 * Called by Reachability whenever status changes.
 */
- (void)reachabilityChanged:(NSNotification *)note
{
    Reachability *curReach = [note object];
    [self printNetworkInfo:curReach];
}

- (void)printNetworkInfo:(Reachability *)reachability
{    
    NSLog(@"AppDelegate reachabilityChanged currentReachabilityStatus:%ld", (long)reachability.currentReachabilityStatus);
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
    // Override point for customization after application launch.
    NSLog(@"[[NSDate date] timeIntervalSince1970] %@", [@([[NSDate date] timeIntervalSince1970]) stringValue]);
    [self checkQCloudAppInfo];
    
    
//    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(reachabilityChanged:) name:kReachabilityChangedNotification object:nil];
//    self.internetReachability = [Reachability reachabilityWithHostName:@"www.baidu.com"];
//    [self.internetReachability startNotifier];
//    [self printNetworkInfo:self.internetReachability];
            
    return YES;
}


- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
}


- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}


- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
}


- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}


- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}


@end
